#pragma once

#include <iostream>

namespace spin
{

    struct SerialNumber
    {
        static SerialNumber parse(std::string serialNumberString)
        {
            return SerialNumber(serialNumberString);
        }

        inline friend std::ostream &operator<<(std::ostream &out, const SerialNumber &serialNumber)
        {
            out << serialNumber.serialNumber_ << std::endl;
            return out;
        }

        inline std::string toString() const { return serialNumber_; }

        inline bool operator==(const SerialNumber &other) const
        {
            return serialNumber_ == other.serialNumber_;
        }

    private:
        SerialNumber(std::string serialNumberString) : serialNumber_(serialNumberString) {}
        const std::string serialNumber_;
    };

} // namespace spin